using System;
using System.Data;
using System.Web.UI;


namespace Telerik.AJAXExamplesCSharp.AJAX.Examples.Common.LoadingUserControls
{
	/// <summary>
	/// Summary description for DefaultCS.
	/// </summary>
	public partial class DefaultCS : System.Web.UI.Page
	{
		
		
		
		
		
			
		private void Page_Load(object sender, System.EventArgs e)
		{								
			if (LatestLoadedControlName != null)
			{
				LoadUserControl(LatestLoadedControlName);
			}
			else
			{
				LoadUserControl("LoginCS.ascx");
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.lbLogin.Click += new System.EventHandler(this.lbLogin_Click);
			this.lbSearch.Click += new System.EventHandler(this.lbSearch_Click);
			this.lbTasks.Click += new System.EventHandler(this.lbTasks_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void lbLogin_Click(object sender, System.EventArgs e)
		{
			LoadUserControl("LoginCS.ascx");
		}

		public void LoadUserControl(string controlName)
		{
			if (LatestLoadedControlName != null)
			{
				Control previousControl = Panel1.FindControl(LatestLoadedControlName.Split('.')[0]);
                if (!Object.Equals(previousControl, null))
				{
					this.Panel1.Controls.Remove(previousControl);
				}
			}
			string userControlID = controlName.Split('.')[0];
			Control targetControl = Panel1.FindControl(userControlID);
            if (Object.Equals(targetControl, null))
			{
				UserControl userControl = (UserControl) this.LoadControl(controlName);
				//slashes and tildes are forbidden
				userControl.ID = userControlID.Replace("/", "").Replace("~", "");
				this.Panel1.Controls.Add(userControl);
				LatestLoadedControlName = controlName;
			}
		}

		private void lbSearch_Click(object sender, System.EventArgs e)
		{
			if (!Logged)
			{
				Panel1.Controls.Clear();
				Panel1.Controls.Add(new LiteralControl("To access this control you have to log in."));
			}
			else
			{
				LoadUserControl("SearchCS.ascx");
			}
		}

		private void lbTasks_Click(object sender, System.EventArgs e)
		{
			if (!Logged)
			{
				Panel1.Controls.Clear();
				Panel1.Controls.Add(new LiteralControl("To access this control you have to log in."));
			}
			else
			{
				LoadUserControl("TasksCS.ascx");
			}		
		}

		public bool Logged
		{
			get
			{			
				if (ViewState["Logged"] == null)
				{
					return false;
				}
				else
				{
					return (bool) (ViewState["Logged"]);
				}
			}
			set
			{
				ViewState["Logged"] = value;
			}
		}

		private string LatestLoadedControlName
		{
			get
			{
				return (string) ViewState["LatestLoadedControlName"];
			}
			set
			{
				ViewState["LatestLoadedControlName"] = value;
			}		
		}

		public DataTable TasksTable
		{
			get
			{
				return (DataTable) ViewState["TasksTable"];
			}
			set
			{
				ViewState["TasksTable"] = value;
			}
		}

		public DataTable Tasks
		{
			get
			{
				DataTable dataTable = new DataTable();
				if (ViewState["Tasks"] == null)
				{					
					dataTable.Columns.Add("TaskName", typeof(string));
					dataTable.Columns.Add("Status", typeof(bool));

					dataTable.Rows.Add(new Object[] {"Task1", false});
					dataTable.Rows.Add(new Object[] {"Task2", true});
					dataTable.Rows.Add(new Object[] {"Task3", false});
					dataTable.Rows.Add(new Object[] {"Task4", true});
					dataTable.Rows.Add(new Object[] {"Task5", false});
					
					ViewState["Tasks"] = dataTable;
				}
				else
				{
					dataTable = (DataTable) ViewState["Tasks"];	
				}				
				return dataTable;
			}
			set
			{
				ViewState["Tasks"] = value;
			}
		}				
	}
}
